﻿@customization @bypass-integration
Feature: Branch tag

Rule: Add branch-tag for an existing scenario if changed

@tc:169
Scenario: Branch-tag is added to an unlinked scenario
	rule: Add branch-tag for an existing scenario if changed
	Given there is a remote server project
	And the synchronizer is configured to use branch-tag prefix "tc.mybranch"
	And there is a scenario in the local repository that should not be synchronized yet
		"""
		Scenario: Sample scenario
			When I do something
		"""
	When the local repository is synchronized with push
	Then a new Test Case "Scenario: Sample scenario" should be created in the remote server
	And the Test Case should contain the following steps
		| step                |
		| When I do something |
	And a tag "@tc.mybranch:[id-of-new-test-case]" should be added to the scenario in the local repository

@tc:170
Scenario: Branch-tag is added to a linked scenario when changed
	rule: Add branch-tag for an existing scenario if changed
	Given there is a remote server project
	And there is an existing synchronized scenario
		"""
		@tc:[id-of-test-case]
		Scenario: Sample scenario
			When I do something
		"""
	And the synchronizer is configured to use branch-tag prefix "tc.mybranch"
	When the scenario is updated to:
		"""
		@tc:[id-of-test-case]
		Scenario: UPDATED scenario
			When I do something NEW
		"""
	And the local repository is synchronized with push
	Then a new Test Case "Scenario: UPDATED scenario" should be created in the remote server
	And the Test Case should contain the following steps
		| step                    |
		| When I do something NEW |
	And a tag "@tc.mybranch:[id-of-new-test-case]" should be added to the scenario in the local repository

@tc:171
Scenario: Scenario without branch-tag is unchanged if the test case is up-to-date
	rule: Add branch-tag for an existing scenario if changed
	Given there is a remote server project
	And there is an existing synchronized scenario
		"""
		@tc:[id-of-test-case]
		Scenario: Sample scenario
			When I do something
		"""
	And the synchronizer is configured to use branch-tag prefix "tc.mybranch"
	When the local repository is synchronized with push
	Then the Test Case should not be changed
	And the feature file in the local repository should not change

Rule: Update branch-tagged test case if exists

@tc:172
Scenario: Update test case identified by the branch-tag when updated
	rule: Update branch-tagged test case if exists
	Given there is a remote server project
	And the synchronizer is configured to use branch-tag prefix "tc.mybranch"
	And there is an existing synchronized scenario on a branch
		"""
		@tc:[id-of-trunk-test-case] @tc.mybranch:[id-of-test-case]
		Scenario: Sample scenario modified on a branch
			When I do something
		"""
	When the scenario is updated to:
		"""
		@tc:[id-of-trunk-test-case] @tc.mybranch:[id-of-test-case]
		Scenario: UPDATED scenario modified on a branch
			When I do something NEW
		"""
	And the local repository is synchronized with push
	Then the Test Case title should be updated to "Scenario: UPDATED scenario modified on a branch"
	And the feature file in the local repository should not change