﻿@customization 
@notSupported:JIRA.DataCenter.ZephyrScale @notSupported:JIRA.DataCenter.JiraTcm
Feature: Ignore TestCase steps

@tc:178
Scenario: Ignores prefixed steps when updating test case
	Given there is a remote server project
	And the synchronizer is configured to skip Test Case steps starting with
         | prefix |
         | SKIP   |       
	And there is a new Test Case as
		| field | value                                                         |
		| title | Scenario: Sample scenario                                     |
		| steps | SKIP this step; Given there is something; When I do something |
	And there is a scenario in the local repository
		"""
		@tc:[id-of-test-case]
		Scenario: Updated sample scenario
			When I do something new
			Then something will change
		"""
	When the local repository is synchronized with push
	Then the Test Case title should be updated to "Scenario: Updated sample scenario"
	And the Test Case should contain the following steps
		| step                       |
		| SKIP this step             |
		| When I do something new    |
		| Then something will change |

@tc:179
Scenario: Should only ignore leading steps
	Given there is a remote server project
	And the synchronizer is configured to skip Test Case steps starting with
         | prefix |
         | SKIP   |       
	And there is a new Test Case as
		| field | value                                                         |
		| title | Scenario: Sample scenario                                     |
		| steps | Given there is something; SKIP this step; When I do something |
	And there is a scenario in the local repository
		"""
		@tc:[id-of-test-case]
		Scenario: Updated sample scenario
			When I do something new
			Then something will change
		"""
	When the local repository is synchronized with push
	Then the Test Case title should be updated to "Scenario: Updated sample scenario"
	And the Test Case should contain the following steps
		| step                       |
		| When I do something new    |
		| Then something will change |

@tc:180
Scenario: Do not update scenario if not changed, even if there are ignored steps
	Given there is a remote server project
	And the synchronizer is configured to skip Test Case steps starting with
         | prefix |
		 | SKIP   |
	And there is an existing synchronized scenario
		"""
		Scenario: Sample scenario
			Given there is something
			When I do something
		"""
	When the Test Case steps are updated to 
		| keyword | text               |
		|         | SKIP this step     |
		| Given   | there is something |
		| When    | I do something     |
	When the local repository is synchronized with push
	Then the Test Case should not be changed
	And the log should not contain "CONFLICT"

@tc:181
Scenario: Pull does not add ignored steps to the feature
	Given there is a remote server project
	And the synchronizer is configured to enable pull
	And the synchronizer is configured to skip Test Case steps starting with
         | prefix |
		 | SKIP   |
	And there is an existing synchronized feature file
		"""
		Feature: Sample feature

		Scenario: Sample scenario
			Given there is something
			When I do something
		"""
	When the Test Case steps are updated to 
		| keyword | text                       |
		|         | SKIP this step             |
		| Given   | there is something changed |
		| When    | I do something             |
	And the local repository is synchronized with pull
	Then the feature file in the local repository should be updated to:
		"""
		Feature: Sample feature

		@tc:[id-of-test-case]
		Scenario: Sample scenario
			Given there is something changed
			When I do something
		"""	